#include "Stopwatch.h"



// XgbvEHb`̏
void InitStopwatch(StopwatchData* pStopwatchData)
{
	QueryPerformanceFrequency(&pStopwatchData->Freq);
	ResetStopwatch(pStopwatchData);
}

// XgbvEHb`̏
void ResetStopwatch(StopwatchData* pStopwatchData)
{
	QueryPerformanceCounter(&pStopwatchData->Start);
}

// XgbvEHb`̏
double GetElapsedTime(StopwatchData* pStopwatchData)
{
	LARGE_INTEGER End;
	QueryPerformanceCounter(&End);

	const LONGLONG TICK_DELTA	= 1000000000;
	const double INV_TICK_DELTA	= 1.0 / (double)TICK_DELTA;

	LONGLONG elapsed = (End.QuadPart - pStopwatchData->Start.QuadPart);
	return (double)((elapsed * TICK_DELTA) / pStopwatchData->Freq.QuadPart) * INV_TICK_DELTA;
}
