#include "Window.h"

// EBhEnh
static HWND g_hWnd = NULL;
// IʒmĂ邩H
static bool g_isQuitMessage = false;

// EChEvV[W[
static LRESULT CALLBACK WndProc(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uiMsg )
	{
	case WM_CLOSE:		// ۂWindowj
		DestroyWindow(hWnd);
		return 0;
	case WM_DESTROY:	// vȌIʒm
		PostQuitMessage(0);
		return 0L;
	}
	// ̃EBhEvV[WĂяo
	return DefWindowProc(hWnd, uiMsg, wParam, lParam);
}

// VvȃEBhE̍쐬
bool CreateSimpleWindow(const TCHAR* pName, int x, int y, int width, int height)
{
	WNDCLASSEX wcex;
	// EChE̐ݒ
	wcex.cbSize			= sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= GetModuleHandle(NULL);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= pName;
	wcex.hIcon			= LoadIcon(NULL, IDC_ARROW);
	wcex.hIconSm		= LoadIcon(NULL, IDI_APPLICATION);
	RegisterClassExW(&wcex);

	DWORD dwStyle = WS_OVERLAPPEDWINDOW;

	RECT Rect;
	Rect.left	= 0;
	Rect.top	= 0; 
	Rect.right	= width;
	Rect.bottom	= height;
	// EBhẼX^Cɍ킹K؂ȃTCY擾
	AdjustWindowRect(&Rect, dwStyle, false);

	width = Rect.right - Rect.left;
	height = Rect.bottom - Rect.top;

	// EChE̐
	g_hWnd = CreateWindow(wcex.lpszClassName,
		pName,
		dwStyle,
		x,
		y,
		width,
		height,
		NULL,
		NULL,
		GetModuleHandle(NULL),
		NULL);
	if( g_hWnd == NULL )
	{
		return false;
	}

	// EChE̕\
	ShowWindow(g_hWnd, SW_SHOW);
	UpdateWindow(g_hWnd);

	return true;
}

// bZ[W̍XV
bool UpdateWindowMessage(void)
{
	MSG msg;
	// bZ[W݂邩mF
	if( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) )
	{
		// IʒmĂꍇ͔
		if( msg.message == WM_QUIT )
		{
			g_isQuitMessage = true;
		}
		else
		{
			// bZ[WEChEvV[Wɓ]
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		return true;
	}
	return false;
}

// IʒmĂ邩H
bool IsQuitMessage(void) { return g_isQuitMessage; }

// EBhEnh̎擾
HWND GetWindowHandle(void) { return g_hWnd; }