#include "DrawBuffer.h"


// _obt@̐
IDirect3DVertexBuffer9* CreateVertexBuffer(const void* pVertices, UINT size)
{
	IDirect3DVertexBuffer9* pVertexBuffer;
	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	// w肵TCY̒_obt@쐬
	if( FAILED(pDevice->CreateVertexBuffer(size, 0, 0, D3DPOOL_MANAGED, &pVertexBuffer, NULL)) )
	{
		return NULL;
	}
	void* pData;
	// obt@bNăf[^
	if( SUCCEEDED(pVertexBuffer->Lock(0, size, &pData, 0)) )
	{
		memcpy(pData, pVertices, size);
		pVertexBuffer->Unlock();
	}
	return pVertexBuffer;
}

// CfbNXobt@̐
IDirect3DIndexBuffer9* CreateIndexBuffer(const UINT16* pIndeces, UINT size)
{
	IDirect3DIndexBuffer9* pIndexBuffer;
	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	// 16byte^̃CfbNXobt@쐬
	if( FAILED(pDevice->CreateIndexBuffer(size, 0, D3DFMT_INDEX16, D3DPOOL_MANAGED, &pIndexBuffer, NULL)) )
	{
		return NULL;
	}
	void* pData;
	// obt@bNăf[^
	if( SUCCEEDED(pIndexBuffer->Lock(0, size, &pData, 0)) )
	{
		memcpy(pData, pIndeces, size);
		pIndexBuffer->Unlock();
	}
	return pIndexBuffer;
}
