#include "SceneManager.h"
#include <windows.h>

static SceneProc g_currentScene;

// V[Ǘ̏
void InitializeSceneManager(void)
{
	ZeroMemory(&g_currentScene, sizeof(g_currentScene));
}

// V[Ǘ̉
void FinalizeSceneManager(void)
{
	// Ō͉ďI
	if( g_currentScene.Final ) g_currentScene.Final();

	ZeroMemory(&g_currentScene, sizeof(g_currentScene));
}

// V[̍XV
void UpdateSceneManager(void)
{
	if( g_currentScene.Update ) g_currentScene.Update();
}

// V[̕`
void RenderSceneManager(void)
{
	if( g_currentScene.Render ) g_currentScene.Render();
}

// V[̑J
bool JumpScene(SetupFunc Func)
{
	// ݂̃V[
	if( g_currentScene.Final ) g_currentScene.Final();

	ZeroMemory(&g_currentScene, sizeof(g_currentScene));

	bool ret = true;
	// ̃V[Ώ
	if( Func )
	{
		g_currentScene = Func();
		if( g_currentScene.Init ) ret = g_currentScene.Init();
	}
	return ret;
}

// V[̎擾
const char* GetSceneName(void)
{
	if( g_currentScene.Name ) return g_currentScene.Name;
	return "Unknown";
}