#pragma once


// p֐`
typedef	bool (*InitFunc)(void);
// p֐`
typedef	void (*FinalFunc)(void);
// XVp֐`
typedef	void (*UpdateFunc)(void);
// `p֐`
typedef	void (*RenderFunc)(void);


// V[ݒp\
struct SceneProc
{
	const char*		Name;
	InitFunc		Init;
	FinalFunc		Final;
	UpdateFunc		Update;
	RenderFunc		Render;
};

typedef SceneProc (*SetupFunc)(void);


// V[Ǘ̏
void InitializeSceneManager(void);
// V[Ǘ̉
void FinalizeSceneManager(void);
// V[̍XV
void UpdateSceneManager(void);
// V[̕`
void RenderSceneManager(void);


// V[̑J
bool JumpScene(SetupFunc Func);
// V[̎擾
const char* GetSceneName(void);