#include "Window.h"
#include "DirectX.h"
#include "SystemScene.h"


// Gg[|Cg
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	int width = 640;
	int height = 480;
	if( !CreateSimpleWindow(TEXT("DirectX9"), 0, 0, width, height) )
	{
		return false;
	}


	InitializeDirectX(GetWindowHandle(), width, height, false);
	// V[VXȅ
	InitializeSceneManager();

	// VXeV[֑Jڂ
	JumpScene(SetupSystemScene);
	// C[v
	while( !IsQuitMessage() )
	{
		if( !UpdateWindowMessage() )
		{
			UpdateSceneManager();

			BeginRenderScene();
			{
				ClearBackBuffer(D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER|D3DCLEAR_STENCIL, 0x00000000, 1.0f, 0);

				SetDefaultRenderState();
				
				RenderSceneManager();
			}
			EndRenderScene();
			FlipDisp();
		}
	}
	// V[VXȅI
	FinalizeSceneManager();
	FinalizeDirectX();

	return 0;
}
